/*
 *    Copyright 2021 The European Language Grid
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package eu.elg.ltservice;

import eu.elg.model.Failure;
import eu.elg.model.StandardMessages;
import eu.elg.model.StatusMessage;
import io.micronaut.http.HttpStatus;
import io.micronaut.http.exceptions.HttpStatusException;

import java.util.Optional;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * Exception allowing a handler to return specific {@link StatusMessage}s rather than a generic "Internal error".
 */
public class ELGException extends HttpStatusException {

  private final StatusMessage[] status;

  /**
   * Create an exception with a given status message (which should not be null)
   *
   * @param status status messages to return.
   */
  public ELGException(StatusMessage... status) {
    this(HttpStatus.INTERNAL_SERVER_ERROR, status);
  }

  /**
   * Create an exception with a given HTTP response code and one or more status messages.
   *
   * @param httpStatus HTTP status code to return for this exception if the caller expects a single JSON value.  Ignored
   *                   for SSE responses, which always use code 200.
   * @param status     status messages
   */
  public ELGException(HttpStatus httpStatus, StatusMessage... status) {
    super(httpStatus, "");
    this.status = status;
  }

  /**
   * Create an exception with a given status message (which should not be null), and an underlying cause.  The cause
   * will not be forwarded to the caller but may be useful for local logging in the worker process.
   *
   * @param cause  the underlying exception that caused this one.
   * @param status status messages to return.
   */
  public ELGException(Throwable cause, StatusMessage... status) {
    this(HttpStatus.INTERNAL_SERVER_ERROR, cause, status);
  }

  /**
   * Create an exception with a given HTTP response code and one or more status messages (which should not be null), and
   * an underlying cause.  The cause will not be forwarded to the caller but may be useful for local logging in the
   * worker process.
   *
   * @param httpStatus HTTP status code to return for this exception if the caller expects a single JSON value.  Ignored
   *                   for SSE responses, which always use code 200.
   * @param cause      the underlying exception that caused this one.
   * @param status     status messages to return.
   */
  public ELGException(HttpStatus httpStatus, Throwable cause, StatusMessage... status) {
    super(httpStatus, "");
    this.status = status;
    this.initCause(cause);
  }

  /**
   * @return the status message that should be returned to the caller.
   */
  public Optional<Object> getBody() {
    Failure fail = new Failure();
    if(status != null) {
      fail.withErrors(status);
    } else {
      fail.withErrors(StandardMessages.elgServiceInternalError(getMessage()));
    }
    return Optional.of(fail.asMessage());
  }

  /**
   * Convert and concatenate all the status messages
   *
   * @return a string representation of this error generated by concatenating the status messages.
   */
  public String getMessage() {
    return "[" +
            (status == null ? Stream.<StatusMessage>empty() : Stream.of(status))
                    .map((msg) ->
                            msg.getCode() + " / " + msg.getText() +
                                    ((msg.getParams() == null || msg.getParams().isEmpty()) ? ""
                                            : " / " + msg.getParams()))
                    .collect(Collectors.joining(", ")) +
            "]";
  }
}
